/*
-- =====================================================================
-- CUSTODEL - Custo do delivery baseado no manual
-- =====================================================================
*/
CREATE OR REPLACE PROCEDURE CUSTODEL(
P_CDSEQCUSMA IN OUT CUSTOSEMA.CDSEQCUSSE%TYPE, -- Deve ser passado para o parmetro '0000000000'.
P_CDSEQITEM  IN OUT NUMBER,
P_IDINSERES  IN VARCHAR DEFAULT 'N', -- 'S' - Insere Servio;  'N' - No Insere Servio.
P_IDINSEREP  IN VARCHAR DEFAULT 'N', -- 'S' - Insere Produto;  'N' - No Insere Produto; 'P' - Insere Somente os Produtos Principais.
P_IDINSERER  IN VARCHAR DEFAULT 'N', -- 'S' - Insere Receita;  'N' - No Insere Receita; 'P' - Insere Somente as Receitas Principais.
P_CDFILIAL   IN FILIAL.CDFILIAL%TYPE,
P_DTINI      IN PLANOVOO.DTHRPLAVOOPV%TYPE,
P_DTFIN      IN PLANOVOO.DTHRPLAVOOPV%TYPE,
P_CDOPERADOR IN OPERADOR.CDOPERADOR%TYPE,

VRCUSULCLIQMAN OUT NUMBER,
VRCUSULCBRUMAN OUT NUMBER,
VRCUSMEDLIQMAN OUT NUMBER,
VRCUSMEDBRUMAN OUT NUMBER
) AS
V_CUSULCLIQSER NUMBER;
V_CUSULCBRUSER NUMBER;
V_CUSMEDLIQSER NUMBER;
V_CUSMEDBRUSER NUMBER;

V_CUSULCLIQMANT NUMBER;
V_CUSULCBRUMANT NUMBER;
V_CUSMEDLIQMANT NUMBER;
V_CUSMEDBRUMANT NUMBER;

BEGIN
   V_CUSULCLIQMANT := 0;
   V_CUSULCBRUMANT := 0;
   V_CUSMEDLIQMANT := 0;
   V_CUSMEDBRUMANT := 0;

   FOR C_SERV IN (SELECT SP.CDCIA,MC.CDMANCIA,SM.CDSERVICO,/*SM.CDCLASSE,SM.CDCICLO,*/SP.DTHRPLAVOOPV
                  FROM SERVPLANO SP, DELIVERY DE, MANUALCIA MC, SERVMANUAL SM
                  WHERE (SP.CDFILIAL    = P_CDFILIAL  ) AND
                        (SP.DTHRPLAVOOPV BETWEEN P_DTINI AND P_DTFIN) AND
                        (SP.IDSITSERSP <> '3'         ) AND
                        (DE.CDFILIAL    = P_CDFILIAL  ) AND
                        (DE.CDCIA       = SP.CDCIA    ) AND
                        (DE.NRDELIVERY  = SP.NRDELIVERY) AND
                        (DE.IDSITDEL    = '2'         ) AND
                        (MC.CDFILIAL    = P_CDFILIAL  ) AND
                        (MC.CDCIA       = SP.CDCIA    ) AND
                        (MC.IDSITMANCIA = '2'         ) AND
                        (SP.DTHRPLAVOOPV BETWEEN MC.DTINIVGMA AND MC.DTFIMVGMA) AND
                        (SM.CDFILIAL    = P_CDFILIAL  ) AND
                        (SM.CDCIA       = SP.CDCIA    ) AND
                        (SM.CDMANCIA    = MC.CDMANCIA ) AND
                        (SM.CDSERVICO   = SP.CDSERVICO)/* AND
                        (SM.CDCLASSE    = SP.CDCLASSE ) AND
                        (SM.CDCICLO     = SP.CDCICLO  )*/ /*AND
                        (SM.IDSITSEMA   = '2'         ) AND
                        (SP.DTHRPLAVOOPV BETWEEN SM.DTINIVGSEMA AND SM.DTFIMVGSEMA)*/) LOOP

      CUSTOSERV(P_CDSEQCUSMA,'M',P_CDSEQITEM,P_IDINSERES,
                P_IDINSEREP,P_IDINSERER,P_CDFILIAL,C_SERV.CDCIA,
                C_SERV.CDMANCIA,C_SERV.CDSERVICO,/*C_SERV.CDCLASSE,C_SERV.CDCICLO,*/NULL,
                C_SERV.DTHRPLAVOOPV,P_CDOPERADOR,V_CUSULCLIQSER,V_CUSULCBRUSER,
                V_CUSMEDLIQSER,V_CUSMEDBRUSER);

      V_CUSULCLIQMANT := V_CUSULCLIQMANT + V_CUSULCLIQSER;
      V_CUSULCBRUMANT := V_CUSULCBRUMANT + V_CUSULCBRUSER;
      V_CUSMEDLIQMANT := V_CUSMEDLIQMANT + V_CUSMEDLIQSER;
      V_CUSMEDBRUMANT := V_CUSMEDBRUMANT + V_CUSMEDBRUSER;
   END LOOP;

   VRCUSULCLIQMAN := V_CUSULCLIQMANT;
   VRCUSULCBRUMAN := V_CUSULCBRUMANT;
   VRCUSMEDLIQMAN := V_CUSMEDLIQMANT;
   VRCUSMEDBRUMAN := V_CUSMEDBRUMANT;
END;
/

