/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: TRG_DTULTATU_MARC                                                    */
/*                                                                            */
/* Descrio:                                                                 */
/* Atualiza a data de ultima atualizao da Marca                        */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2000 - Yoris L. de Souza                                             */
/*                                                                            */
/* Manutenes TRG :                                                          */
/*                                                                            */
/******************************************************************************/

/******************************************************************************/
/* @H:\SISTEMAS\DBA\SQL\ORACLE\TRG_DTULTATU_MARC.SQL                        */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_MARC'  and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
  DROP TRIGGER DTULTATU_MARC
  GO

CREATE TRIGGER DTULTATU_MARC
ON MARCA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'MARCA', 'CDMARCA=' + CDMARCA+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE MARCA
      SET DTULTATUMARC = GETDATE()
      FROM INSERTED
      WHERE
       ISNULL(MARCA.CDMARCA,0)   = ISNULL(INSERTED.CDMARCA,0);
   END;
END;
GO

