/*

@C:\WIN_V1.53\SQL\ORACLE\1045_RECSTP_GRAVA_CONTA_COMISSAO.SQL;

P_GERA_ERRO = 0 -> COMANDO EXECUTADO
P_GERA_ERRO = 1 -> TIPO DE CONTA DEVE SER INFORMADA
P_GERA_ERRO = 2 -> CLASSIFICACAO FINANCEIRA DEVE SER INFORMADA
P_GERA_ERRO = 3 -> SERIE DEVE SER INFORMADA
P_GERA_ERRO = 4 -> CONTA ATUALIZADA COM SUCESSO

*/

IF EXISTS (SELECT
              *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
	      O.NAME = 'GRAVA_CONTA_COMISSAO' AND
	      TYPE   = 'P' 		      AND
              U.UID  = O.UID                  AND
              U.NAME = USER)

DROP PROCEDURE GRAVA_CONTA_COMISSAO
GO

CREATE PROCEDURE GRAVA_CONTA_COMISSAO
   @P_CDFILIAL     VARCHAR(04),
   @P_CDEMPRESA    VARCHAR(02),
   @P_VRCONTAPAG   NUMERIC(16,2),
   @P_DTCONTAPAG   DATETIME,
   @P_CDFORNECED   VARCHAR(21),
   @P_NRNOTAFISC   VARCHAR(20),
   @P_NRLANCTONF   VARCHAR(10),
   @P_NRLANBOLPAG  VARCHAR(10),
   @P_CDFILIRECE   VARCHAR(04),
   @P_CDVENDEDOR   VARCHAR(04),
   @P_DSCONTAPAG   VARCHAR(100),
   @P_NRPARCPGTOFO DOUBLE PRECISION,
   @P_VRCONTAPARC  FLOAT,
   @P_CDSERIE      VARCHAR(5),
   @P_NRSEQVENPAG  VARCHAR(02),
   @P_GERA_ERRO    VARCHAR(100) OUTPUT,
   @P_CDTPCTPAGAR  VARCHAR(06) OUTPUT
AS
   DECLARE @V_CDINSCESTA     VARCHAR(16);
   DECLARE @V_CDINSCMUNI     VARCHAR(16);
   DECLARE @V_IDTPIJURNF     VARCHAR(01);
   DECLARE @V_NRINSJURNF     VARCHAR(20);
   DECLARE @V_DSTPCTPAGAR    VARCHAR(40);
   DECLARE @V_CDCLASSFINA    VARCHAR(06);
   DECLARE @V_CDTPCTPAGAR    VARCHAR(06);
   DECLARE @V_CDSERIE        VARCHAR(05);
   DECLARE @V_CTNOTA         INTEGER;
   DECLARE @V_NMRAZSOCFORN   VARCHAR(40);
   DECLARE @V_INNRPARC       VARCHAR(2);
   DECLARE @V_DTPARC         DATETIME;
   DECLARE @V_INCOUNT        INTEGER;
   DECLARE @V_NRSEQVENPAG    VARCHAR(02);
   DECLARE @V_NRLANBOLPAG    VARCHAR(20);
   DECLARE @V_PROXLANBOLPAG  VARCHAR(20);
   DECLARE @V_CONCATENA      VARCHAR(30)   
   DECLARE @V_IDTPFORPGTFO   VARCHAR(1);
   DECLARE @V_IDFORMAPGTO    VARCHAR(1);
   DECLARE @V_IDUTDIAPGTO    VARCHAR(1);
   DECLARE @V_NRDIAPGFIXO    DOUBLE PRECISION;
   DECLARE @V_CDFORMPGTO     VARCHAR(2);
   DECLARE @V_NRPARCPGTO     DOUBLE PRECISION;
   DECLARE @V_PARCELA        VARCHAR(2);
   DECLARE @V_VRPARCVENC     FLOAT;
   DECLARE @V_DTVENCIMENTO   DATETIME;
   DECLARE @V_IDTIPODTPGTO   VARCHAR(4);
   DECLARE @V_IDTPPERIODO    VARCHAR(1);
   DECLARE @V_INDIAS         INTEGER;
   DECLARE @V_INGUARDANRDIAS INTEGER;
   DECLARE @V_CDFORNECED     VARCHAR(21);
   DECLARE @V_NRDIASPGTOFO   INTEGER;
   DECLARE @V_VRPERCPGTOFO   FLOAT;
   DECLARE @V_IDTPPERIOD0    VARCHAR;

   /* VARIVEIS DO CURSOR C_CONTAPAG */
   DECLARE @V_CONTAPAG_CDFILIAL     VARCHAR(04);
   DECLARE @V_CONTAPAG_NRLANCTONF   VARCHAR(10);
   DECLARE @V_CONTAPAG_NRSEQVENPAG  VARCHAR(02);
   DECLARE @V_CONTAPAG_NRPARCELAPAG VARCHAR(02);
   DECLARE @V_CONTAPAG_CDFILIBPAG   VARCHAR(04);
   DECLARE @V_CONTAPAG_NRLANBOLPAG  VARCHAR(10);
   DECLARE @V_CONTAPAG_CDEMPRESA    VARCHAR(02);
   DECLARE @V_CONTAPAG_CDFIMOVFLPAG VARCHAR(04);
   DECLARE @V_CONTAPAG_DTMOVFLUXO   DATETIME;
   DECLARE @V_CONTAPAG_CDCLASSFINA  VARCHAR(06);

BEGIN
   SELECT
      @V_CTNOTA = COUNT(*)
   FROM NOTAFISCAL
   WHERE
      CDFILIAL   = @P_CDFILIAL AND
      NRLANCTONF = @P_NRLANCTONF;

   IF @V_CTNOTA = 0 BEGIN
      SELECT @V_CDINSCESTA = MAX(CDINSCESTA),
             @V_CDINSCMUNI = MAX(CDINSCMUNI)
      FROM EMPRCNTRFIL
      WHERE (CDFILIAL  = @P_CDFILIRECE) AND
            (CDEMPRESA = @P_CDEMPRESA);

      IF (@V_CDINSCESTA IS NULL) OR (@V_CDINSCMUNI IS NULL) BEGIN
         SELECT @V_CDINSCESTA = MAX(CDINSCESTA),
                @V_CDINSCMUNI = MAX(CDINSCMUNI)
         FROM FILIAL
         WHERE (CDFILIAL  = @P_CDFILIRECE) AND
               (CDEMPRESA = @P_CDEMPRESA);
      END;

      SELECT @V_IDTPIJURNF  = MAX(IDTPIJURFORN),
             @V_NRINSJURNF  = MAX(NRINSJURFORN),
             @V_CDTPCTPAGAR = MAX(CDTPCTPAGAR),
             @V_NMRAZSOCFORN = MAX(NMRAZSOCFORN)
      FROM FORNECEDOR
      WHERE CDFORNECED = @P_CDFORNECED;
      
      SELECT @V_IDFORMAPGTO  = F.IDTPFORPGTFO , 
             @V_IDUTDIAPGTO  = F.IDUTDIAPGTFO , 
             @V_NRDIAPGFIXO  = F.NRDIAPGFIXFO ,
             @V_IDTIPODTPGTO = FP.IDTIPODTPGTO, 
             @V_CDFORMPGTO   = F.CDFORMPGTO   , 
             @V_IDTPPERIOD0  = FP.IDTPPERIODO ,
             @V_NRPARCPGTO   = F.NRPARCPGTOFO
        FROM FORNECEDOR F LEFT JOIN FORMPGTO FP 
          ON (F.CDFORMPGTO = FP.CDFORMPGTO)   
       WHERE (F.CDFORNECED = @P_CDFORNECED);

      IF @V_CDTPCTPAGAR IS NULL BEGIN
         SELECT @V_CDTPCTPAGAR = MAX(CDTPCTPAGAR)
         FROM TIPOOPERAC
         WHERE CDTIPOOPER   = '12' AND
               IDENTRSAIDOP = 'E';
      END;

      IF NOT @V_CDTPCTPAGAR IS NULL BEGIN
         SELECT @V_DSTPCTPAGAR = MAX(DSTPCTPAGAR),
                @V_CDCLASSFINA = MAX(CDCLASSFINA)
         FROM TIPOCTPAGAR
         WHERE CDTPCTPAGAR = @V_CDTPCTPAGAR;
      END;

      SET @P_GERA_ERRO   = '0';
      SET @P_CDTPCTPAGAR = @V_CDTPCTPAGAR;

      IF (@V_CDTPCTPAGAR IS NULL) BEGIN
         SET @P_GERA_ERRO = '1' + '@' + @V_IDTPIJURNF + '@' + @V_NRINSJURNF + '@' + @V_NMRAZSOCFORN;
      END;

      IF (@P_GERA_ERRO   = '0') BEGIN
         IF (@V_CDCLASSFINA IS NULL) BEGIN
            SET @P_GERA_ERRO = '2'+'@'+@V_CDTPCTPAGAR+' - '+ @V_DSTPCTPAGAR;
         END;
      END;

      IF @P_GERA_ERRO = '0' BEGIN
         INSERT INTO NOTAFISCAL
            (CDFILIAL   , NRLANCTONF  , CDEMPRESA , CDINSCESTA , CDINSCMUNI ,
             IDTPIJURNF , NRINSJURNF  , CDFORNECED, IDBLOQUEADO, IDDOCFISCAL,
             IDDOCFINANC, NRNOTAFISC  , DTEMISSAO , DTENTRSAID , VRPRODUTOS ,
             VRNOTAFISC , IDENTRSAIDOP, CDTIPOOPER, IDDOCCONTAB, IDSTATUS   ,
             IDSISTEMA  , CDSERIEENTR , CDFILIRECE, CDVENDEDOR)
         VALUES
            (@P_CDFILIAL  , @P_NRLANCTONF, @P_CDEMPRESA , @V_CDINSCESTA, @V_CDINSCMUNI,
             @V_IDTPIJURNF, @V_NRINSJURNF, @P_CDFORNECED, 'S'          , 'N'          ,
             'S'          , @P_NRNOTAFISC, @P_DTCONTAPAG, @P_DTCONTAPAG, @P_VRCONTAPAG,
             @P_VRCONTAPAG, 'E'          , '12'         , 'S'          , 'A'          ,
             'PAG'        , @P_CDSERIE   , @P_CDFILIRECE, @P_CDVENDEDOR);
             
/* ================================ SEM FORMA DE PAGAMENTO =========================================== */         
         IF ((@V_IDFORMAPGTO IS NULL) OR ((@V_IDFORMAPGTO <> 'F') AND (@V_IDFORMAPGTO <> 'V'))) BEGIN
            --V_NRPARCELAS := 1;
      
            INSERT INTO BOLETPAGAR
               (CDFILIAL   , NRLANBOLPAG, CDFORNECED  , CDEMPRESA , VRBOLPAG,
                VRFINALBPAG, DTVENBOLPAG, IDHABIBPAG  , IDSTATBPAG,
                IDBPAGREAL , IDSITUCNABP, NRPARCBOLPAG)
            VALUES
               (@P_CDFILIAL  , @P_NRLANBOLPAG, @P_CDFORNECED, @P_CDEMPRESA,  @P_VRCONTAPAG,
                @P_VRCONTAPAG, @P_DTCONTAPAG , 'N'          , 'A'         ,
                'N'          , '00'          , '00');              

            -- - ATUALIZA O FLUXO DE CAIXA -------------------------- --
            EXEC ATUALIZA_FLUXO_DE_CAIXA @P_CDEMPRESA  ,
                                         @P_CDFILIAL   ,
                                         @P_DTCONTAPAG ,
                                         'E'           ,
                                         @V_CDCLASSFINA,
                                         0             ,
                                         @P_VRCONTAPAG;                                             

            IF ((@P_NRSEQVENPAG IS NULL) OR (@P_NRSEQVENPAG = '')) BEGIN
               SET @V_NRSEQVENPAG = '00';
            END
            ELSE BEGIN
               SET @V_NRSEQVENPAG = @P_NRSEQVENPAG;
            END;   

            INSERT INTO CONTAPAGAR
               (CDFILIAL    , NRLANCTONF  , NRSEQVENPAG, NRPARCELAPAG, CDTPCTPAGAR,
                QTDIASVENPAG, DTORIGVENPAG, VRORIGPAG  , DTATUAVENPAG, VRATUAPAG  ,
                IDSTATPAG   , DSCONTAPAG  , CDFILIBPAG , NRLANBOLPAG , CDCLASSFINA,
                CDEMPRESA   , CDFIMOVFLPAG, DTMOVFLUXO , IDMOVFLUXO)
            VALUES
               (@P_CDFILIAL , @P_NRLANCTONF, @V_NRSEQVENPAG, '00'         , @V_CDTPCTPAGAR,
                '0'         , @P_DTCONTAPAG, @P_VRCONTAPAG , @P_DTCONTAPAG, @P_VRCONTAPAG ,
                'A', @P_DSCONTAPAG + ' - ' + @V_DSTPCTPAGAR, @P_CDFILIAL  , @V_NRLANBOLPAG, @V_CDCLASSFINA,
                @P_CDEMPRESA, @P_CDFILIAL  , @P_DTCONTAPAG , 'E');                
         END  
/* =============================== FORMA DE PAGAMENTO FIXA =========================================== */      
         ELSE IF (@V_IDFORMAPGTO = 'F') BEGIN
            
            SET @V_INCOUNT       = 0;
            SET @V_INNRPARC      = 01;
            SET @V_DTPARC        = NULL;
            SET @V_DTVENCIMENTO  = @P_DTCONTAPAG;
            SET @V_NRLANBOLPAG   = @P_NRLANBOLPAG;
            SET @V_VRPARCVENC    = 0;
            SET @V_DTPARC        = @P_DTCONTAPAG;
               
            IF NOT (@V_NRPARCPGTO > 1) BEGIN
               SET @V_NRPARCPGTO = 1;
               SET @V_INNRPARC   = 0;
            END;
            SET @V_VRPARCVENC    = @P_VRCONTAPAG / @V_NRPARCPGTO;
               
            IF NOT (@V_DTVENCIMENTO IS NULL) BEGIN
               /* FORMA FIXA Verifica se o numero informado no cadastro de forma de pagamento  maior
               ou igual ao dia da data de vencimento. Ou se o opo de gerar 1 parcela no proximo mes
               esteja marcada  */
               IF (@V_IDUTDIAPGTO = 'I') BEGIN
                  IF (@V_NRDIAPGFIXO >= DAY(@V_DTVENCIMENTO)) BEGIN
                     /* pega o maior dia do mes */
                     SET @V_INDIAS = CONVERT(DOUBLE PRECISION, DAY((DATEADD(MM,1, @V_DTVENCIMENTO)-DAY(@V_DTVENCIMENTO))));
                     /* Verifica se numero informado no cadastro de forma de pagamento 
                         maior que o ultimo dia do mes. Exemplo informou 31 no cadastro e o ultimo dia do e 30*/
                     IF (@V_NRDIAPGFIXO > @V_INDIAS) BEGIN
                        /*Pega o maior dia do mes */
                        SET @V_DTVENCIMENTO = (DATEADD(MM,1, @V_DTVENCIMENTO)-DAY(@V_DTVENCIMENTO));
                     END   
                     ELSE BEGIN
                               /*Joga a data com o dia informado na parametrizcao */
                        SET @V_DTVENCIMENTO = CONVERT(DATETIME, CONVERT(VARCHAR, @V_NRDIAPGFIXO)+'/'+ CONVERT(VARCHAR, MONTH(@V_DTVENCIMENTO)) +'/'+ CONVERT(VARCHAR, YEAR(@V_DTVENCIMENTO)), 103);                        
                     END;
                  END   
                  ELSE BEGIN
                     SET @V_DTVENCIMENTO = DATEADD(MM, 1, @V_DTVENCIMENTO);
                     SET @V_DTVENCIMENTO = CONVERT(DATETIME, CONVERT(VARCHAR, @V_NRDIAPGFIXO)+'/'+ CONVERT(VARCHAR, MONTH(@V_DTVENCIMENTO)) +'/'+ CONVERT(VARCHAR, YEAR(@V_DTVENCIMENTO)), 103);                     
                  END;
               END   
               ELSE BEGIN
                  SET @V_DTVENCIMENTO = DATEADD(MM, 1, @V_DTVENCIMENTO);
                  SET @V_DTVENCIMENTO = CONVERT(DATETIME, CONVERT(VARCHAR, @V_NRDIAPGFIXO)+'/'+ CONVERT(VARCHAR, MONTH(@V_DTVENCIMENTO)) +'/'+ CONVERT(VARCHAR, YEAR(@V_DTVENCIMENTO)), 103);                  
               END;
            END;   
            
            WHILE (@V_INCOUNT <> @V_NRPARCPGTO) BEGIN
            
               SET @V_PROXLANBOLPAG = NULL;
         
               IF ((@P_NRSEQVENPAG IS NULL) OR (@P_NRSEQVENPAG = '')) BEGIN
                  SET @V_NRSEQVENPAG = '00';
               END   
               ELSE BEGIN
                  SET @V_NRSEQVENPAG = @P_NRSEQVENPAG;
               END;   
                 
               SELECT @V_DTVENCIMENTO = DATEADD(MM, @V_INCOUNT, @V_DTVENCIMENTO)
                 FROM CONTAPAGAR;                 
                        
               INSERT INTO BOLETPAGAR
                  (CDFILIAL   , NRLANBOLPAG, CDFORNECED  , CDEMPRESA , VRBOLPAG,
                   VRFINALBPAG, DTVENBOLPAG, IDHABIBPAG  , IDSTATBPAG,
                   IDBPAGREAL , IDSITUCNABP, NRPARCBOLPAG)
               VALUES
                  (@P_CDFILIAL  , @V_NRLANBOLPAG , @P_CDFORNECED, @P_CDEMPRESA, @V_VRPARCVENC,
                   @V_VRPARCVENC, @V_DTVENCIMENTO, 'N'          , 'A'         ,
                   'N'          , '00'           , '00');
                                               
               -- - ATUALIZA O FLUXO DE CAIXA -------------------------- --
               EXEC ATUALIZA_FLUXO_DE_CAIXA @P_CDEMPRESA   ,
                                            @P_CDFILIAL    ,
                                            @V_DTVENCIMENTO,
                                            'E'            ,
                                            @V_CDCLASSFINA ,
                                            0              ,
                                            @V_VRPARCVENC;                                                     
                   
               INSERT INTO CONTAPAGAR
                  (CDFILIAL    , NRLANCTONF  , NRSEQVENPAG, NRPARCELAPAG, CDTPCTPAGAR,
                   QTDIASVENPAG, DTORIGVENPAG, VRORIGPAG  , DTATUAVENPAG, VRATUAPAG  ,
                   IDSTATPAG   , DSCONTAPAG  , CDFILIBPAG , NRLANBOLPAG , CDCLASSFINA,
                   CDEMPRESA   , CDFIMOVFLPAG, DTMOVFLUXO , IDMOVFLUXO)
               VALUES
                  (@P_CDFILIAL , @P_NRLANCTONF  , @V_NRSEQVENPAG , RIGHT(REPLICATE(0, 2) + @V_INNRPARC, 2), @V_CDTPCTPAGAR,
                   '0'         , @V_DTVENCIMENTO, @V_VRPARCVENC  , @V_DTVENCIMENTO, @V_VRPARCVENC ,
                   'A', @P_DSCONTAPAG + ' - ' + @V_DSTPCTPAGAR   , @P_CDFILIAL    , @V_NRLANBOLPAG, @V_CDCLASSFINA,
                   @P_CDEMPRESA, @P_CDFILIAL    , @V_DTVENCIMENTO, 'E');                   
             
               SET @V_INCOUNT  = @V_INCOUNT  + 1;
               SET @V_INNRPARC = @V_INNRPARC + 1;
               
               IF (@V_NRPARCPGTO > 1) BEGIN 
                  SET @V_CONCATENA = 'BOLETPAGAR'+@P_CDFILIAL;
                  EXEC NOVO_CODIGO @V_CONCATENA, @V_PROXLANBOLPAG OUTPUT, 1;
                  SET @V_NRLANBOLPAG = SUBSTRING(@V_PROXLANBOLPAG, 11, 10);  
               END;
                            
            END;
         END;
/* ============================= FORMA DE PAGAMENTO VARIVEL ========================================= */      
         ELSE BEGIN
            --V_SEQUENCIAL := 1;
            --V_VRPARCAUXI := 0;
            SET @V_PARCELA       = 0;
            SET @V_DTPARC        = NULL;
            SET @V_INCOUNT       = 0;                
            SET @V_DTVENCIMENTO  = @P_DTCONTAPAG;
            SET @V_NRLANBOLPAG   = @P_NRLANBOLPAG;            

            SELECT @V_INCOUNT = COUNT(*)                        
              FROM PRAZOPGTFORN
             WHERE (CDFORNECED = @P_CDFORNECED); 
             
            IF (@V_INCOUNT > 1) BEGIN
               SET @V_PARCELA = 1;
            END;  
               
            IF NOT (@V_IDFORMAPGTO IS NULL) BEGIN
               IF (@V_IDFORMAPGTO = 'V') BEGIN
                  IF (@V_IDTIPODTPGTO = 'EMIN') BEGIN
                     SET @V_INDIAS = 0;
                     SET @V_DTPARC = @P_DTCONTAPAG;
                  END   
                  ELSE IF (@V_IDTIPODTPGTO = 'EMEX') BEGIN
                     SET @V_INDIAS = 1;
                     SET @V_DTPARC = @P_DTCONTAPAG;
                  END   
                  ELSE IF (@V_IDTIPODTPGTO = 'ENIN') BEGIN
                     SET @V_INDIAS = 0;
                     SET @V_DTPARC = @P_DTCONTAPAG;
                  END   
                  ELSE IF (@V_IDTIPODTPGTO = 'ENEX') BEGIN
                     SET @V_INDIAS = 1;
                     SET @V_DTPARC = @P_DTCONTAPAG;
                  END   
                  ELSE IF (@V_IDTIPODTPGTO = 'UEMI') BEGIN
                     SET @V_INDIAS = 0;
                     SET @V_DTPARC = @P_DTCONTAPAG;
                  END   
                  ELSE IF (@V_IDTIPODTPGTO = 'UEME') BEGIN
                     SET @V_INDIAS = 1;
                     SET @V_DTPARC = @P_DTCONTAPAG;   
                  END;
               END;
            END;   

       --PARCELAS PARA GERAO DE TIPO DE PAGAMENTO VARIVEL
            DECLARE C_PRAZOPGTFORN CURSOR FOR 
            (SELECT CDFORNECED,
                    CONVERT(FLOAT, NRDIASPGTOFO) AS NRDIASPGTOFO,
                    VRPERCPGTOFO
               FROM PRAZOPGTFORN
              WHERE (CDFORNECED = @P_CDFORNECED))
              
            OPEN C_PRAZOPGTFORN;
            FETCH NEXT FROM C_PRAZOPGTFORN INTO @V_CDFORNECED, @V_NRDIASPGTOFO, @V_VRPERCPGTOFO;
            WHILE @@FETCH_STATUS = 0 BEGIN
               
               SET   @V_PROXLANBOLPAG  = NULL;
               SET   @V_DTVENCIMENTO   = NULL;
               SET   @V_INGUARDANRDIAS = NULL;               
               
               IF NOT (@V_VRPERCPGTOFO = 0) BEGIN
                  SET @V_VRPARCVENC = (@P_VRCONTAPAG * (@V_VRPERCPGTOFO / 100));
                 --   @V_VRPARCAUXI = @V_VRPARCAUXI + @V_VRPARCVENC;
               END;   
                  
               IF (@V_NRDIASPGTOFO = 0) BEGIN
                  SET @V_INGUARDANRDIAS = @V_INDIAS +1;
               END
               ELSE BEGIN
                  SET @V_INGUARDANRDIAS = @V_INDIAS + @V_NRDIASPGTOFO;
               END;
                  
               IF NOT (@P_DTCONTAPAG IS NULL) BEGIN
                  SET @V_DTVENCIMENTO = @P_DTCONTAPAG + @V_INGUARDANRDIAS;
               END;
               
               IF @V_IDTPPERIODO = 'M' BEGIN
                  SET @V_DTVENCIMENTO = TEKNISA.DIAMES(@V_CDFORMPGTO,
                                                       @V_DTVENCIMENTO);
               END
               ELSE BEGIN
                  IF @V_IDTPPERIODO = 'S' BEGIN
                     SET @V_DTVENCIMENTO = TEKNISA.DIASEMANA(@V_CDFORMPGTO,
                                                             @V_DTVENCIMENTO);
                  END
                  ELSE BEGIN
                     SET @V_DTVENCIMENTO = TEKNISA.DIASEMANAMES(@V_CDFORMPGTO,
                                                                @V_DTVENCIMENTO);
                  END;
               END;
 
                  
            /*    Feriado bancrio  
            IF V_BOCONSFERIBANC THEN
                     CONSISTE_FERI_BANC(P_CDFILIEMIRECE,
                                        V_DTVENCIMENTO,
                                        V_DTVENCIMENTO,
                                        V_IDTIPODTPGT,
                                        P_DTEMISSAO);
                  END IF; */
                  
               IF ((@P_NRSEQVENPAG IS NULL) OR (@P_NRSEQVENPAG = '')) BEGIN
                  SET @V_NRSEQVENPAG = '00';
               END      
               ELSE BEGIN
                  SET @V_NRSEQVENPAG = @P_NRSEQVENPAG;
               END; 
                      
               INSERT INTO BOLETPAGAR
                  (CDFILIAL   , NRLANBOLPAG, CDFORNECED  , CDEMPRESA , VRBOLPAG,
                   VRFINALBPAG, DTVENBOLPAG, IDHABIBPAG  , IDSTATBPAG,
                   IDBPAGREAL , IDSITUCNABP, NRPARCBOLPAG)
               VALUES
                  (@P_CDFILIAL  , @V_NRLANBOLPAG , @P_CDFORNECED, @P_CDEMPRESA, @V_VRPARCVENC,
                   @V_VRPARCVENC, @V_DTVENCIMENTO, 'N'          , 'A'         ,
                   'N'          , '00'           , '00');                      
                                                  
               -- - ATUALIZA O FLUXO DE CAIXA -------------------------- --
               EXEC ATUALIZA_FLUXO_DE_CAIXA @P_CDEMPRESA   ,
                                            @P_CDFILIAL    ,
                                            @V_DTVENCIMENTO,
                                            'E'            ,
                                            @V_CDCLASSFINA ,
                                            0              ,
                                            @V_VRPARCVENC;                                                     
                   
               INSERT INTO CONTAPAGAR
                  (CDFILIAL    , NRLANCTONF  , NRSEQVENPAG, NRPARCELAPAG, CDTPCTPAGAR,
                   QTDIASVENPAG, DTORIGVENPAG, VRORIGPAG  , DTATUAVENPAG, VRATUAPAG  ,
                   IDSTATPAG   , DSCONTAPAG  , CDFILIBPAG , NRLANBOLPAG , CDCLASSFINA,
                   CDEMPRESA   , CDFIMOVFLPAG, DTMOVFLUXO , IDMOVFLUXO)
               VALUES
                  (@P_CDFILIAL , @P_NRLANCTONF  , @V_NRSEQVENPAG , RIGHT(REPLICATE(0, 2) + @V_INNRPARC, 2), @V_CDTPCTPAGAR,
                   '0'         , @V_DTVENCIMENTO, @V_VRPARCVENC  , @V_DTVENCIMENTO, @V_VRPARCVENC ,
                   'A', @P_DSCONTAPAG + ' - ' + @V_DSTPCTPAGAR   , @P_CDFILIAL    , @V_NRLANBOLPAG, @V_CDCLASSFINA,
                   @P_CDEMPRESA, @P_CDFILIAL    , @V_DTVENCIMENTO, 'E');                                                                   
                  
               SET @V_PARCELA = @V_PARCELA + 1;
               IF (@V_INCOUNT > 1) BEGIN
                  SET @V_CONCATENA = 'BOLETPAGAR'+@P_CDFILIAL;
                  EXEC NOVO_CODIGO @V_CONCATENA, @V_PROXLANBOLPAG OUTPUT, 1;
                  SET @V_NRLANBOLPAG = SUBSTRING(@V_PROXLANBOLPAG, 11,10);     
               END;                    
               FETCH NEXT FROM C_PRAZOPGTFORN INTO @V_CDFORNECED, @V_NRDIASPGTOFO, @V_VRPERCPGTOFO;
            END;
            CLOSE C_PRAZOPGTFORN;
            DEALLOCATE C_PRAZOPGTFORN;
         END;   
/* =================================================================================================== */             
      END;
   END
   ELSE BEGIN
      SET @P_GERA_ERRO = '4';
      UPDATE NOTAFISCAL
      SET VRNOTAFISC = (VRNOTAFISC + @P_VRCONTAPAG)
      WHERE
         CDFILIAL   = @P_CDFILIAL AND
         NRLANCTONF = @P_NRLANCTONF;

      DECLARE C_CONTAPAG CURSOR FOR
      SELECT CDFILIAL,     NRLANCTONF,   NRSEQVENPAG,
             NRPARCELAPAG, CDFILIBPAG,   NRLANBOLPAG,
             CDEMPRESA,    CDFIMOVFLPAG, DTMOVFLUXO,
             CDCLASSFINA
      FROM CONTAPAGAR
      WHERE
         CDFILIAL   = @P_CDFILIAL AND
         NRLANCTONF = @P_NRLANCTONF;

      OPEN C_CONTAPAG;

      FETCH NEXT FROM C_CONTAPAG INTO @V_CONTAPAG_CDFILIAL,     @V_CONTAPAG_NRLANCTONF,   @V_CONTAPAG_NRSEQVENPAG,
                                      @V_CONTAPAG_NRPARCELAPAG, @V_CONTAPAG_CDFILIBPAG,   @V_CONTAPAG_NRLANBOLPAG,
                                      @V_CONTAPAG_CDEMPRESA,    @V_CONTAPAG_CDFIMOVFLPAG, @V_CONTAPAG_DTMOVFLUXO,
                                      @V_CONTAPAG_CDCLASSFINA;

      WHILE (@@FETCH_STATUS = 0) BEGIN


         EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CONTAPAG_CDEMPRESA,
                                      @V_CONTAPAG_CDFIMOVFLPAG,
                                      @V_CONTAPAG_DTMOVFLUXO,
                                      'E',
                                      @V_CONTAPAG_CDCLASSFINA,
                                      0,
                                      @P_VRCONTAPAG;

         UPDATE CONTAPAGAR
         SET VRORIGPAG = (VRORIGPAG + @P_VRCONTAPAG),
             VRATUAPAG = (VRATUAPAG + @P_VRCONTAPAG)
         WHERE
            CDFILIAL     = @V_CONTAPAG_CDFILIAL    AND
            NRLANCTONF   = @V_CONTAPAG_NRLANCTONF  AND
            NRSEQVENPAG  = @V_CONTAPAG_NRSEQVENPAG AND
            NRPARCELAPAG = @V_CONTAPAG_NRPARCELAPAG;

         UPDATE BOLETPAGAR
         SET VRBOLPAG    = (VRBOLPAG + @P_VRCONTAPAG),
             VRFINALBPAG = (VRFINALBPAG + @P_VRCONTAPAG)
         WHERE
            CDFILIAL    = @V_CONTAPAG_CDFILIBPAG AND
            NRLANBOLPAG = @V_CONTAPAG_NRLANBOLPAG;

         FETCH NEXT FROM C_CONTAPAG INTO @V_CONTAPAG_CDFILIAL,     @V_CONTAPAG_NRLANCTONF,   @V_CONTAPAG_NRSEQVENPAG,
                                         @V_CONTAPAG_NRPARCELAPAG, @V_CONTAPAG_CDFILIBPAG,   @V_CONTAPAG_NRLANBOLPAG,
                                         @V_CONTAPAG_CDEMPRESA,    @V_CONTAPAG_CDFIMOVFLPAG, @V_CONTAPAG_DTMOVFLUXO,
                                         @V_CONTAPAG_CDCLASSFINA;
      END;
      CLOSE C_CONTAPAG;
      DEALLOCATE C_CONTAPAG;
   END;
END;
GO



-- VERSAO --
EXEC ATUVEROBJ 'GRAVA_CONTA_COMISSAO','5.05.021';
GO

